#!/bin/sh

#############################################################################################################
#
#GNUPanel es un programa para el control de hospedaje WEB 
#Copyright (C) 2006  Ricardo Marcelo Alvarez rmalvarezkai@gmail.com
#
#------------------------------------------------------------------------------------------------------------
#
#Este archivo es parte de GNUPanel.
#
#	GNUPanel es Software Libre; Usted puede redistribuirlo y/o modificarlo
#	bajo los trminos de la GNU Licencia Pblica General (GPL) tal y como ha sido
#	pblicada por la Free Software Foundation; o bien la versin 2 de la Licencia,
#	o (a su opcin) cualquier versin posterior.
#
#	GNUPanel se distribuye con la esperanza de que sea til, pero SIN NINGUNA
#	GARANTA; tampoco las implcitas garantas de MERCANTILIDAD o ADECUACIN A UN
#	PROPSITO PARTICULAR. Consulte la GNU General Public License (GPL) para ms
#	detalles.
#
#	Usted debe recibir una copia de la GNU General Public License (GPL)
#	junto con GNUPanel; si no, escriba a la Free Software Foundation Inc.
#	51 Franklin Street, 5 Piso, Boston, MA 02110-1301, USA.
#
#------------------------------------------------------------------------------------------------------------
#
#This file is part of GNUPanel.
#
#	GNUPanel is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	GNUPanel is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with GNUPanel; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
#------------------------------------------------------------------------------------------------------------
#
#############################################################################################################
    
function instala_dependencias
    {
    if [ -f ${PROGRAMAS} ]
    then
    ${APT} update
    lista_programas=`${CAT} ${PROGRAMAS} | ${GREP} -v "#" | ${GREP} -v "^ " `
    for entrada in ${lista_programas}
    do
    ${APT} install ${entrada}
    done
    else
    echo "No existe el archivo con el listado de programas a instalar."
    fi
    }

function configura_postgresql
    {
    ${CP} -b -f ${SKEL}/etc/postgresql/pg_hba.conf /etc/postgresql/8.1/main/pg_hba.conf
    ${CP} -b -f ${SKEL}/etc/postgresql/postgresql.conf /etc/postgresql/8.1/main/postgresql.conf
    ${CMODO} 640 /etc/postgresql/8.1/main/pg_hba.conf
    ${CUSUARIO} root:postgres /etc/postgresql/8.1/main/pg_hba.conf
    ${CMODO} 640 /etc/postgresql/8.1/main/postgresql.conf
    ${CUSUARIO} root:postgres /etc/postgresql/8.1/main/postgresql.conf

    /etc/init.d/postgresql-8.1 restart
    }

function configura_mailman
    {
    cat ${SKEL}/etc/mailman/mm_cfg.py | sed -e 's/DOMINIO_PRINCIPAL/'"${DOMINIO_PRINCIPAL}"'/g'  > /etc/mailman/mm_cfg.py
    newlist mailman
    /etc/init.d/mailman restart
    }

function configura_powerdns
    {
    /etc/init.d/pdns stop
    /etc/init.d/pdns-nat stop
    mkdir -p /etc/powerdns/pdns-nat.d
    sleep 1
    cat ${SKEL}/etc/powerdns/pdns.conf | sed -e 's/ALLOW_RECURSION/'"${IP_ALLOW_RECURSION}"'/' -e 's/IP_QUE_ATIENDE/'"${IP}"'/' -e 's/DNS_QUE_CONSULTA/'"${IP_DNS_PROVEEDOR}"'/' > /etc/powerdns/pdns.conf
    cat ${SKEL}/etc/powerdns/pdns-nat.conf | sed -e 's/ALLOW_RECURSION/'"${IP_ALLOW_RECURSION}"'/' -e 's/IP_QUE_ATIENDE/'"${IP}"'/' -e 's/DNS_QUE_CONSULTA/'"${IP_DNS_PROVEEDOR}"'/' > /etc/powerdns/pdns-nat.conf
    cat ${SKEL}/etc/powerdns/pdns.d/pdns.local | sed -e 's/PASS_PDNS_PG/'"${PDNS_PG}"'/' > /etc/powerdns/pdns.d/pdns.local
    cat ${SKEL}/etc/powerdns/pdns-nat.d/pdns.local | sed -e 's/PASS_PDNS_PG/'"${PDNS_PG}"'/' > /etc/powerdns/pdns-nat.d/pdns.local
    cp -p -f /etc/init.d/pdns /etc/init.d/pdns-nat
    update-rc.d pdns-nat defaults 20
    ${CMODO} 600 /etc/powerdns/pdns.conf
    ${CMODO} 600 /etc/powerdns/pdns.d/pdns.local
    ${CUSUARIO} root:root /etc/powerdns/pdns.conf
    ${CUSUARIO} root:root /etc/powerdns/pdns.d/pdns.local

    ${CMODO} 600 /etc/powerdns/pdns-nat.conf
    ${CMODO} 600 /etc/powerdns/pdns-nat.d/pdns.local
    ${CUSUARIO} root:root /etc/powerdns/pdns-nat.conf
    ${CUSUARIO} root:root /etc/powerdns/pdns-nat.d/pdns.local
    
    FALSO=`cat /etc/resolv.conf | grep nameserver | grep localhost`
    if [ -z "${FALSO}" ];
    then
    cat /etc/resolv.conf > /tmp/resuelve.conf
    echo "nameserver localhost" > /etc/resolv.conf
    cat /tmp/resuelve.conf >> /etc/resolv.conf
    rm -f /tmp/resuelve.conf
    else
    echo ""
    fi
    sleep 1
    /etc/init.d/pdns start
    /etc/init.d/pdns-nat start
    }

function configura_apache2
    {
    /etc/init.d/apache2 stop
    adduser www-data ftpgroup

    if [ -f /var/log/apache2/transfer_pg.log ];
    then
    chmod 640 /var/log/apache2/transfer_pg.log
    chown root:adm /var/log/apache2/transfer_pg.log
    else
    echo "" > /var/log/apache2/transfer_pg.log
    chmod 640 /var/log/apache2/transfer_pg.log
    chown root:adm /var/log/apache2/transfer_pg.log
    fi
    
    if [ -f /var/log/apache2/transfer.log ];
    then
    chmod 640 /var/log/apache2/transfer.log
    chown root:adm /var/log/apache2/transfer.log
    else
    echo "" > /var/log/apache2/transfer.log
    chmod 640 /var/log/apache2/transfer.log
    chown root:adm /var/log/apache2/transfer.log
    fi

    cat ${SKEL}/etc/apache2/apache2.conf > /etc/apache2/apache2.conf
    cat ${SKEL}/etc/apache2/ports.conf > /etc/apache2/ports.conf
    cat ${SKEL}/etc/apache2/sites-available/default | sed -e 's/IP_DEL_SERVIDOR/'"${IP}"'/' | sed -e 's/DOMINIO_DEL_SERVIDOR/'"${DOMINIO_PRINCIPAL}"'/g' | sed -e 's/CORREO_ADMIN/'"${CORREO_ADMIN}"'/' > /usr/share/gnupanel/etc/apache2/sites-available/default
    ln -s /usr/share/gnupanel/etc/apache2/sites-available/default /usr/share/gnupanel/etc/apache2/sites-enabled/999999999999-default 
    sleep 1
    cat ${SKEL}/etc/apache2/apache2.pam | sed 's/PASAPORTE/'"${APACHE_PG}"'/' > /etc/pam.d/apache2
    chmod 640 /etc/pam.d/apache2
    chown root:www-data /etc/pam.d/apache2
    a2enmod authz_user
    a2enmod php5
    a2enmod ssl
    a2dismod auth_basic
    sleep 1
    /etc/init.d/apache2 start
    }

function configura_proftpd
    {
    /etc/init.d/proftpd stop
    sleep 1
    addgroup --gid 4000 ftpgroup
    useradd -u 4000 -s /bin/false -d ${DIR_BASE} -g ftpgroup ftpuser
    passwd -l ftpuser

    addgroup --gid 5000 proftpd
    useradd -u 5000 -s /bin/false -d ${DIR_BASE} -g proftpd proftpd
    passwd -l proftpd

    if [ -d ${DIR_BASE} ];
    then
    echo "El directorio ${DIR_BASE} ya existe" 
    chown proftpd:proftpd ${DIR_BASE}
    chmod 755 ${DIR_BASE}
    else
    mkdir -p ${DIR_BASE}
    chown proftpd:proftpd ${DIR_BASE}
    chmod 755 ${DIR_BASE}
    fi

    if [ -d /etc/proftpd ];
    then
    echo "El directorio /etc/proftpd ya existe" 
    else
    mkdir /etc/proftpd
    fi
    
    if [ -f /etc/proftpd/proftpd.cert.pem ];
    then
    echo "Ya existe un certificado" 
    else
    if [ -f /etc/proftpd/proftpd.key.pem ];
    then
    rm -f /etc/proftpd/proftpd.key.pem
    fi
    ./make-ssl-cert-proftpd ${SKEL}/etc/proftpd/ssleay.cnf /etc/proftpd/proftpd.cert.pem /etc/proftpd/proftpd.key.pem 365
    fi

    if [ -d /var/log/proftpd ];
    then
    echo "" > /var/log/proftpd/proftpd.log
    echo "" > /var/log/proftpd/tls.log
    else
    mkdir /var/log/proftpd
    echo "" > /var/log/proftpd/proftpd.log
    echo "" > /var/log/proftpd/tls.log
    fi    

    cat ${SKEL}/etc/proftpd/proftpd.conf | sed 's/PASAPORTE/'"${PROFTPD_PG}"'/' > /etc/proftpd/proftpd.conf
    cat ${SKEL}/etc/proftpd/proftpd.pam | sed 's/PASAPORTE/'"${PROFTPD_PG}"'/' > /etc/pam.d/proftpd
    chmod 640 /etc/pam.d/proftpd
    chown root:proftpd /etc/pam.d/proftpd
    
    sleep 1
    FALSO=`cat /etc/shells | grep /bin/false`
    if [  -z ${FALSO} ];
    then
    echo "/bin/false" >> /etc/shells
    else
    echo "El shell /bin/false ya esta en el sistema"
    fi
    /etc/init.d/proftpd start
    }

function configura_postfix
    {

    /etc/init.d/postfix stop
    /etc/init.d/amavis stop
    /etc/init.d/saslauthd stop
    /etc/init.d/courier-imap-ssl stop
    /etc/init.d/courier-pop-ssl stop
    /etc/init.d/courier-imap stop
    /etc/init.d/courier-pop stop
    /etc/init.d/courier-authdaemon stop
    /etc/init.d/clamav-daemon stop    
    /etc/init.d/clamav-freshclam stop    
    sleep 1
    
    addgroup --gid 4001 correos
    useradd -u 4001 -s /bin/false -d /var/mail -g correos correos
    passwd -l correos
    adduser postfix sasl
    adduser amavis clamav
    mkdir -p /var/spool/postfix/var/run/saslauthd
    
    cat ${SKEL}/etc/postfix/main.cf | sed 's/DOMINIO/'"${DOMINIO_PRINCIPAL}"'/g' | sed 's/IP_SERVIDOR/'"${IP}"'/' > /etc/postfix/main.cf
    cat ${SKEL}/etc/postfix/postfix.pam | sed 's/PASAPORTE/'"${POSTFIX_PG}"'/' > /etc/pam.d/smtp
    cat ${SKEL}/etc/postfix/uids.cf | sed 's/PASAPORTE/'"${POSTFIX_PG}"'/' > /etc/postfix/uids.cf
    cat ${SKEL}/etc/postfix/gids.cf | sed 's/PASAPORTE/'"${POSTFIX_PG}"'/' > /etc/postfix/gids.cf
    cat ${SKEL}/etc/postfix/virt.cf | sed 's/PASAPORTE/'"${POSTFIX_PG}"'/' > /etc/postfix/virt.cf
    cat ${SKEL}/etc/postfix/transport.cf | sed 's/PASAPORTE/'"${POSTFIX_PG}"'/' > /etc/postfix/transport.cf
    cat ${SKEL}/etc/postfix/transport_listas.cf | sed 's/PASAPORTE/'"${POSTFIX_PG}"'/' > /etc/postfix/transport_listas.cf
    cat ${SKEL}/etc/postfix/virtual.cf | sed 's/PASAPORTE/'"${POSTFIX_PG}"'/' > /etc/postfix/virtual.cf
    cat ${SKEL}/etc/postfix/aliases.cf | sed 's/PASAPORTE/'"${POSTFIX_PG}"'/' > /etc/postfix/aliases.cf
    cat ${SKEL}/etc/postfix/transport_local | sed 's/DOMINIO/'"${DOMINIO_PRINCIPAL}"'/' > /etc/postfix/transport_local

    mkdir -p /etc/sasl
    cp -f -b ${SKEL}/etc/postfix/sasl/smtpd.conf /etc/postfix/sasl
    chown -R root:postfix /etc/postfix/sasl
    chmod 550 /etc/postfix/sasl
    chmod 440 /etc/postfix/sasl/smtpd.conf
    cp -f -b ${SKEL}/etc/postfix/master.cf /etc/postfix/master.cf
    cp -f -b ${SKEL}/etc/postfix/redes.cf /etc/postfix/redes.cf
    cat ${SKEL}/etc/amavis/conf.d/50-user | sed 's/IP_SERVIDOR/'"${IP}"'/' > /etc/amavis/conf.d/50-user

    cat ${SKEL}/etc/postfix/saslauthd > /etc/default/saslauthd
    mkdir -p /var/log/amavis
    chown amavis:adm /var/log/amavis
    echo "" >> /var/log/amavis/amavis.log
    chown amavis:adm /var/log/amavis/amavis.log
        
    cat ${SKEL}/etc/clamav/clamd.conf > /etc/clamav/clamd.conf
    cat ${SKEL}/etc/clamav/freshclam.conf > /etc/clamav/freshclam.conf
    cat ${SKEL}/etc/postfix/aliases | sed 's/USUARIO_ADMIN/'"${USUARIO_ADMIN}"'/' | sed 's/DOMINIO/'"${DOMINIO_PRINCIPAL}"'/' > /etc/aliases
    postalias /etc/aliases
    postmap /etc/postfix/transport_local
    
    if [ -f /etc/postfix/gnupanel.key ];
    then
    echo "Ya existe un certificado" 
    else
    ./make-ssl-cert-postfix ${SKEL}/etc/postfix/ssleay.cnf ${PALABRA_CLAVE} 365
    echo ""
    fi

    mkdir /var/mail/correos
    chown correos:mail /var/mail/correos
    chmod 2700 /var/mail/correos
    #chown -R amavis:amavis /var/log/clamav
    chown root:postfix /etc/postfix/*
    chmod 640 /etc/postfix/*
    chmod 550 /etc/postfix/postfix-script
    #chown -R amavis:amavis /var/run/clamav/
    chmod 640 /etc/pam.d/smtp
    chown root:sasl /etc/pam.d/smtp
    adduser www-data postfix
    sleep 1

    /etc/init.d/clamav-freshclam start
    /etc/init.d/clamav-daemon start
    /etc/init.d/courier-authdaemon start
    /etc/init.d/courier-pop start
    /etc/init.d/courier-imap start
    /etc/init.d/courier-pop-ssl start
    /etc/init.d/courier-imap-ssl start
    /etc/init.d/saslauthd start
    /etc/init.d/amavis start
    /etc/init.d/postfix start
    }

function configura_courier
    {
    /etc/init.d/courier-imap-ssl stop
    /etc/init.d/courier-pop-ssl stop
    /etc/init.d/courier-imap stop
    /etc/init.d/courier-pop stop
    /etc/init.d/courier-authdaemon stop

    cat ${SKEL}/etc/courier/authdaemonrc > /etc/courier/authdaemonrc
    cat ${SKEL}/etc/courier/authpgsqlrc | sed -e 's/PASAPORTE/'"${POSTFIX_PG}"'/' > /etc/courier/authpgsqlrc
    cat ${SKEL}/etc/courier/imapd.cnf > /etc/courier/imapd.cnf
    cat ${SKEL}/etc/courier/pop3d.cnf > /etc/courier/pop3d.cnf

    if [ -f /etc/courier/imapd.pem ];
    then
    echo "Ya existe un certificado" 
    else
    mkimapdcert
    fi

    if [ -f /etc/courier/pop3d.pem ];
    then
    echo "Ya existe un certificado" 
    else
    mkpop3dcert
    fi

    /etc/init.d/courier-authdaemon start
    /etc/init.d/courier-pop start
    /etc/init.d/courier-imap start
    /etc/init.d/courier-pop-ssl start
    /etc/init.d/courier-imap-ssl start

    }

function configura_mysql
    {
    cat ${SKEL}/etc/mysql/my.cnf > /etc/mysql/my.cnf
    /etc/init.d/mysql restart
    mysqladmin -p -u root password ${MYSQL_PASSWD}
    }

function saca_config_default
    {
    rm -f /etc/apache2/conf.d/phpmyadmin.conf
    rm -f /etc/apache2/conf.d/phppgadmin
    #rm -f /usr/share/phppgadmin/conf/config.inc.php
    #rm -f /etc/phppgadmin/config.inc.php
    #cp -f ${SKEL}/etc/phppgadmin/config.inc.php /usr/share/phppgadmin/conf/
    cat ${SKEL}/etc/phppgadmin/config.inc.php > /etc/phppgadmin/config.inc.php
    #ln -s /usr/share/phppgadmin/conf/config.inc.php /etc/phppgadmin/config.inc.php
    cat ${SKEL}/etc/phpmyadmin/config.inc.php > /etc/phpmyadmin/config.inc.php
    chown root:www-data /etc/phpmyadmin/config.inc.php
    chmod 440 /etc/phpmyadmin/config.inc.php
    
    chown root:www-data /etc/phppgadmin/config.inc.php
    chmod 440 /etc/phppgadmin/config.inc.php
    
    }

function configura_gnupanel
    {
    /etc/init.d/gnupanel-transf stop
    /etc/init.d/pdns-nat stop
    /etc/init.d/pdns stop
    /etc/init.d/apache2 stop
    /etc/init.d/proftpd stop
    /etc/init.d/postfix stop
    /etc/init.d/amavis stop
    /etc/init.d/saslauthd stop
    /etc/init.d/courier-imap-ssl stop
    /etc/init.d/courier-pop-ssl stop
    /etc/init.d/courier-imap stop
    /etc/init.d/courier-pop stop
    /etc/init.d/courier-authdaemon stop
    /etc/init.d/clamav-daemon stop    
    /etc/init.d/clamav-freshclam stop    

    addgroup --gid 8000 gnupanel
    useradd -u 8000 -s /bin/false -d ${DIR_BASE} -g gnupanel gnupanel
    passwd -l gnupanel

#    addgroup --gid 8001 gnupaneld
#    useradd -u 8001 -s /bin/bash -d ${DIR_BASE} -g gnupaneld gnupaneld
#    passwd -l gnupaneld
#    adduser gnupaneld adm
#    adduser gnupaneld gnupanel
#    adduser gnupaneld ftpgroup
#    adduser gnupaneld mail
    
    mkdir -p /etc/gnupanel
    chmod 550 /etc/gnupanel
    chown root:www-data /etc/gnupanel
    sleep 2

    GID_MAIL=`cat /etc/group | grep mail | mawk -F ":" '{print $3;}'`
    
    PASAPORTE_ENC=`php5 -r '$encriptado = NULL; while(!$encriptado) {$calculo=crypt("$argv[1]"); if(!strstr($calculo,"/")) $encriptado = $calculo; } print $encriptado;' ${CONTRASENA_ADMIN}`

#    echo "////////////////////////////////////////"
#    echo "PASAPORTE ${CONTRASENA_ADMIN} ${PASAPORTE_ENC}"    
#    echo ${GNUPANEL_PG}
#    echo ${APACHE_PG}
#    echo ${PDNS_PG}
#    echo ${POSTFIX_PG}
#    echo ${PROFTPD_PG}
#    echo ${PASAPORTE_ENC}
#    echo ${CORREO_ADMIN}
#    echo ${GID_MAIL}
#    echo ${NOMBRE_SERVIDOR}
#    echo ${IDIOMA_ADMIN}
#    echo "////////////////////////////////////////"

    su postgres -c "dropdb gnupanel"

    su postgres -c "dropuser gnupanel"
    su postgres -c "dropuser apache"
    su postgres -c "dropuser proftpd"
    su postgres -c "dropuser postfix"
    su postgres -c "dropuser pdns"
    
    su postgres -c "createdb gnupanel"
    su postgres -c "createlang plpgsql gnupanel"
    su postgres -c "createlang plperl gnupanel"
    
    cat ${SKEL}/etc/gnupanel/gnupanel-post.sql | sed 's/PASAPORTE_GNUPANEL/'"${GNUPANEL_PG}"'/' | sed 's/PASAPORTE_APACHE/'"${APACHE_PG}"'/' | sed 's/PASAPORTE_PDNS/'"${PDNS_PG}"'/' | sed 's/PASAPORTE_POSTFIX/'"${POSTFIX_PG}"'/' | sed 's/PASAPORTE_PROFTPD/'"${PROFTPD_PG}"'/' | sed 's/PASAPORTE/'${PASAPORTE_ENC}'/g' | sed 's/CORREO_ADMIN/'${CORREO_ADMIN}'/g' | sed 's/GID_MAIL/'${GID_MAIL}'/g' | sed 's/NOMBRE_SERVIDOR/'${NOMBRE_SERVIDOR}'/g' | sed 's/IDIOMA_ADMIN/'${IDIOMA_ADMIN}'/g' > ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf
#    cat ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf | sed 's/PASAPORTE_APACHE/'"${APACHE_PG}"'/' > ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf
#    echo "/////////////BEGIN///////////////////////////"
#    cat ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf
#    echo "//////////////END////////////////////////////"

#    cat ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf | sed 's/PASAPORTE_PDNS/'"${PDNS_PG}"'/' > ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf
#    cat ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf | sed 's/PASAPORTE_POSTFIX/'"${POSTFIX_PG}"'/' > ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf

#    cat ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf | sed 's/PASAPORTE_PROFTPD/'"${PROFTPD_PG}"'/' > ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf
#    cat ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf | sed 's/PASAPORTE/'${PASAPORTE_ENC}'/g' > ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf
#    cat ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf | sed 's/CORREO_ADMIN/'${CORREO_ADMIN}'/g' > ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf
#    cat ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf | sed 's/GID_MAIL/'${GID_MAIL}'/g' > ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf
#    cat ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf | sed 's/NOMBRE_SERVIDOR/'${NOMBRE_SERVIDOR}'/g' > ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf
#    cat ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf | sed 's/IDIOMA_ADMIN/'${IDIOMA_ADMIN}'/g' > ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf

    su postgres -c "psql -f ${SKEL}/etc/gnupanel/gnupanel.sql gnupanel"
    su postgres -c "psql -f ${SKEL}/etc/gnupanel/gnupanel-post.sql.conf gnupanel"
    su postgres -c "psql -f ${SKEL}/etc/gnupanel/paises.sql gnupanel"
    su postgres -c "psql -f ${SKEL}/etc/gnupanel/funciones.sql gnupanel"
    su postgres -c "psql -f ${SKEL}/etc/gnupanel/lenguajes-es.sql gnupanel"
    su postgres -c "psql -f ${SKEL}/etc/gnupanel/lenguajes-en.sql gnupanel"

#    cat ${SKEL}/etc/gnupanel/gnupanel.conf.pl | sed 's/PASAPORTE/'"${GNUPANEL_PG}"'/' | sed 's/NOMBRE_SERVIDOR/'"${NOMBRE_SERVIDOR}"'/' | sed 's/DIR_BASE/'"${DIR_BASE}"'/' > /etc/gnupanel/gnupanel.conf.pl
#    cat ${SKEL}/etc/gnupanel/gnupanel.conf.pl | sed 's/PASAPORTE/'"${GNUPANEL_PG}"'/' | sed 's/NOMBRE_SERVIDOR/'"${NOMBRE_SERVIDOR}"'/' | sed 's/CORREO_ADMIN/'"${CORREO_ADMIN}"'/' | sed 's/MYSQL_PASSWD/'"${MYSQL_PASSWD}"'/' | sed 's/DIRECTORIO_BACKUP_TEMP/'"${DIRECTORIO_BACKUP_TEMP}"'/' > /etc/gnupanel/gnupanel.conf.pl
    cat ${SKEL}/etc/gnupanel/gnupanel.conf.pl | sed 's/PASAPORTE/'"${GNUPANEL_PG}"'/' | sed 's/NOMBRE_SERVIDOR/'"${NOMBRE_SERVIDOR}"'/' | sed 's/CORREO_ADMIN/'"${CORREO_ADMIN}"'/' | sed 's/MYSQL_PASSWD/'"${MYSQL_PASSWD}"'/' > /etc/gnupanel/gnupanel.conf.pl


    chmod 640 /etc/gnupanel/gnupanel.conf.pl
    chown -R root:www-data /etc/gnupanel/gnupanel.conf.pl
    mkdir -p /usr/local/gnupanel
    cp -f -R ${SKEL}/usr/local/gnupanel/* /usr/local/gnupanel
    chmod -R 550 /usr/local/gnupanel
    chown -R root:root /usr/local/gnupanel
    chown root:www-data /usr/local/gnupanel
    chown -R root:www-data /usr/local/gnupanel/bin
    mkdir -m 750 -p ${DIRECTORIO_BACKUP_TEMP}
    chown www-data:www-data ${DIRECTORIO_BACKUP_TEMP}
    
    cp -f ${SKEL}/etc/init.d/gnupanel-transf /etc/init.d/
    cp -f ${SKEL}/etc/gnupanel/SKEL_APACHE_GNUPANEL /etc/gnupanel/
    cp -f ${SKEL}/etc/gnupanel/SKEL_APACHE_SUBDOMINIOS /etc/gnupanel/

    cp -f ${SKEL}/etc/cron.d/* /etc/cron.d/
    cp -f ${SKEL}/etc/logrotate.d/* /etc/logrotate.d/
    
    chmod 500 /etc/init.d/gnupanel-transf
    chown root:root /etc/init.d/gnupanel-transf
    update-rc.d gnupanel-transf defaults 99    

    if [ -f /var/log/apache2/transfer_pg.log ];
    then
    chmod 640 /var/log/apache2/transfer_pg.log
    chown root:adm /var/log/apache2/transfer_pg.log
    else
    echo "" > /var/log/apache2/transfer_pg.log
    chmod 640 /var/log/apache2/transfer_pg.log
    chown root:adm /var/log/apache2/transfer_pg.log
    fi

#    if [ -f /var/log/apache-ssl/transfer_pg.log ];
#    then
#    chmod 640 /var/log/apache-ssl/transfer_pg.log
#    chown root:adm /var/log/apache-ssl/transfer_pg.log
#    else
#    echo "" > /var/log/apache-ssl/transfer_pg.log
#    chmod 640 /var/log/apache-ssl/transfer_pg.log
#    chown root:adm /var/log/apache-ssl/transfer_pg.log
#    fi

    if [ -d ${DIR_GNUPANEL} ];
    then
    echo "El directorio  ${DIR_GNUPANEL} ya existe"
    chmod 750 ${DIR_GNUPANEL}
    cp -f -r ${SKEL}/usr/share/gnupanel/* ${DIR_GNUPANEL}
    chown www-data:www-data ${DIR_GNUPANEL}
    else
    mkdir ${DIR_GNUPANEL}
    chmod 750 ${DIR_GNUPANEL}
    cp -f -r ${SKEL}/usr/share/gnupanel/* ${DIR_GNUPANEL}
    chown -R www-data:www-data ${DIR_GNUPANEL}
    fi

    ln -s /usr/share/gnupanel/estilos /usr/share/gnupanel/usuarios/estilos
    ln -s /usr/share/gnupanel/estilos /usr/share/gnupanel/reseller/estilos
    ln -s /usr/share/gnupanel/estilos /usr/share/gnupanel/admin/estilos

    cat ${SKEL}/etc/gnupanel/gnupanel-admin-ini.php | sed 's/PASAPORTE/'"${GNUPANEL_PG}"'/' | sed 's/NOMBRE_SERVIDOR/'"${NOMBRE_SERVIDOR}"'/' | sed 's/GID_MAIL/'"${GID_MAIL}"'/' | sed 's/TRANSFERENCIA_SERVIDOR/'"${TRANSFERENCIA_SERVIDOR}"'/' | sed 's/ESPACIO_SERVIDOR/'"${ESPACIO_SERVIDOR}"'/' > /etc/gnupanel/gnupanel-admin-ini.php
    cat ${SKEL}/etc/gnupanel/gnupanel-reseller-ini.php | sed 's/PASAPORTE/'"${GNUPANEL_PG}"'/' | sed 's/NOMBRE_SERVIDOR/'"${NOMBRE_SERVIDOR}"'/' | sed 's/GID_MAIL/'"${GID_MAIL}"'/' | sed 's/TRANSFERENCIA_SERVIDOR/'"${TRANSFERENCIA_SERVIDOR}"'/' | sed 's/ESPACIO_SERVIDOR/'"${ESPACIO_SERVIDOR}"'/' > /etc/gnupanel/gnupanel-reseller-ini.php
    cat ${SKEL}/etc/gnupanel/gnupanel-usuarios-ini.php | sed 's/PASAPORTE/'"${GNUPANEL_PG}"'/' | sed 's/NOMBRE_SERVIDOR/'"${NOMBRE_SERVIDOR}"'/' | sed 's/GID_MAIL/'"${GID_MAIL}"'/' | sed 's/TRANSFERENCIA_SERVIDOR/'"${TRANSFERENCIA_SERVIDOR}"'/' | sed 's/ESPACIO_SERVIDOR/'"${ESPACIO_SERVIDOR}"'/' | sed 's/MYSQL_PASSWD/'"${MYSQL_PASSWD}"'/' > /etc/gnupanel/gnupanel-usuarios-ini.php

    ln -s /etc/gnupanel/gnupanel-admin-ini.php  /usr/share/gnupanel/admin/config/gnupanel-admin-ini.php
    ln -s /etc/gnupanel/gnupanel-reseller-ini.php /usr/share/gnupanel/reseller/config/gnupanel-reseller-ini.php
    ln -s /etc/gnupanel/gnupanel-usuarios-ini.php /usr/share/gnupanel/usuarios/config/gnupanel-usuarios-ini.php

    chown root:www-data /etc/gnupanel/gnupanel-admin-ini.php
    chown root:www-data /etc/gnupanel/gnupanel-reseller-ini.php
    chown root:www-data /etc/gnupanel/gnupanel-usuarios-ini.php

    chmod 440 /etc/gnupanel/gnupanel-admin-ini.php
    chmod 440 /etc/gnupanel/gnupanel-reseller-ini.php
    chmod 440 /etc/gnupanel/gnupanel-usuarios-ini.php
    mv -f /usr/share/gnupanel/estilos/personalizados/gnupanel.com.ar /usr/share/gnupanel/estilos/personalizados/${DOMINIO_PRINCIPAL}

    mkdir -p /usr/share/phppgadmin/bin
    ln -s /usr/bin/pg_dump /usr/share/phppgadmin/bin/pg_dump
    ln -s /usr/bin/pg_dumpall /usr/share/phppgadmin/bin/pg_dumpall
    saca_config_default
    cat ${SKEL}/etc/sudo/sudoers >> /etc/sudoers

    ./permisos_gnupanel ${SKEL}
    sleep 1

    /etc/init.d/gnupanel-transf start
    /etc/init.d/courier-authdaemon start
    /etc/init.d/courier-pop start
    /etc/init.d/courier-imap start
    /etc/init.d/courier-pop-ssl start
    /etc/init.d/courier-imap-ssl start
    /etc/init.d/clamav-freshclam start    
    /etc/init.d/clamav-daemon start    
    /etc/init.d/saslauthd start
    /etc/init.d/amavis start
    /etc/init.d/postfix start
    /etc/init.d/proftpd start
    /etc/init.d/apache2 start
    /etc/init.d/pdns start
    /etc/init.d/pdns-nat start
    /etc/init.d/cron restart
    /etc/init.d/sudo restart
    }

#########################################################################################################
APT=/usr/bin/apt-get
PROGRAMAS=./listado.apt
CAT=/bin/cat
GREP=/bin/grep
SKEL=skel
CP=/bin/cp
CUSUARIO=/bin/chown
CMODO=/bin/chmod
TIEMPO=`date +%s`

. configuracion.txt

DIR_GNUPANEL=/usr/share/gnupanel

DIR_BASE=/var/www/sitios/

DIRECTORIO_BACKUP_TEMP=/var/www/gnupanel-backups

USUARIO_ADMIN=admin

IDIOMA_ADMIN=es



echo ""
echo ""
echo ""
echo ""
echo "############################################################################################################################################"
echo "############################################################################################################################################"
echo "############################################################################################################################################"
echo "############################################################################################################################################"

echo "su nombre de usuario administrador del GNUPanel sera"
echo "${USUARIO_ADMIN}"

echo "El sistema provee tanto SMTP y POP con ssl aunque no es obligatorio "
echo "Conviene configurar su cliente de correo para usar tanto POP como SMTP con ssl"
echo "La instalacion por defecto genera certificados para apache-ssl, postfix-tls, proftpd-tls "
echo "courier-pop-ssl y courier-imap-ssl estos certificados son genericos y no estan firmados por ninguna  "
echo "entidad certificadora. "

echo ""
echo -n "Desea comenzar a configurar su panel:(si/no):"
#read SEGUIR
SEGUIR=si

if [ "${SEGUIR}" != "si" ];
then
echo "Su panel no ha sido configurado, cuando lo desee vuelva a ejecutar este script para configurarlo"
exit
fi

#########################################################################################################

instala_dependencias

configura_postgresql

configura_mysql

configura_gnupanel

configura_powerdns

configura_proftpd

configura_apache2

configura_mailman

configura_postfix

configura_courier

#########################################################################################################

echo "Se a terminado de configurar el panel de control ingrese en"
echo "${IP_PRINCIPAL}"
echo "Y configure los datos extras"

#########################################################################################################






