#!/bin/sh

#############################################################################################################
#
#GNUPanel es un programa para el control de hospedaje WEB 
#Copyright (C) 2006  Ricardo Marcelo Alvarez rmalvarezkai@gmail.com
#
#------------------------------------------------------------------------------------------------------------
#
#Este archivo es parte de GNUPanel.
#
#	GNUPanel es Software Libre; Usted puede redistribuirlo y/o modificarlo
#	bajo los trminos de la GNU Licencia Pblica General (GPL) tal y como ha sido
#	pblicada por la Free Software Foundation; o bien la versin 2 de la Licencia,
#	o (a su opcin) cualquier versin posterior.
#
#	GNUPanel se distribuye con la esperanza de que sea til, pero SIN NINGUNA
#	GARANTA; tampoco las implcitas garantas de MERCANTILIDAD o ADECUACIN A UN
#	PROPSITO PARTICULAR. Consulte la GNU General Public License (GPL) para ms
#	detalles.
#
#	Usted debe recibir una copia de la GNU General Public License (GPL)
#	junto con GNUPanel; si no, escriba a la Free Software Foundation Inc.
#	51 Franklin Street, 5 Piso, Boston, MA 02110-1301, USA.
#
#------------------------------------------------------------------------------------------------------------
#
#This file is part of GNUPanel.
#
#	GNUPanel is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	GNUPanel is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with GNUPanel; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
#------------------------------------------------------------------------------------------------------------
#
#############################################################################################################
    
function instala_dependencias
    {
    if [ -f ${PROGRAMAS} ]
    then
    ${APT} update
    lista_programas=`${CAT} ${PROGRAMAS} | ${GREP} -v "#" | ${GREP} -v "^ " `
    for entrada in ${lista_programas}
    do
    ${APT} install ${entrada}
    done
    else
    echo "No existe el archivo con el listado de programas a instalar."
    fi
    }

function update_gnupanel
    {

    su postgres -c "psql -f ${SKEL}/etc/gnupanel/gnupanel-update.sql gnupanel"
    su postgres -c "psql -f ${SKEL}/etc/gnupanel/lenguajes-es.sql gnupanel"
    su postgres -c "psql -f ${SKEL}/etc/gnupanel/lenguajes-en.sql gnupanel"
    rm -f -r /usr/share/gnupanel/estilos/*
    cp -f -R ${SKEL}/usr/local/gnupanel/* /usr/local/gnupanel
    chmod -R 550 /usr/local/gnupanel
    chown -R root:root /usr/local/gnupanel
    chown root:www-data /usr/local/gnupanel
    chown -R root:www-data /usr/local/gnupanel/bin
    chown www-data:www-data ${DIRECTORIO_BACKUP_TEMP}
    
    cp -f ${SKEL}/etc/init.d/gnupanel-transf /etc/init.d/
    chmod 500 /etc/init.d/gnupanel-transf
    chown root:root /etc/init.d/gnupanel-transf

    chmod 750 ${DIR_GNUPANEL}
    cp -f -r ${SKEL}/usr/share/gnupanel/* ${DIR_GNUPANEL}
    chown www-data:www-data ${DIR_GNUPANEL}

    chmod 440 /etc/gnupanel/gnupanel-admin-ini.php
    chmod 440 /etc/gnupanel/gnupanel-reseller-ini.php
    chmod 440 /etc/gnupanel/gnupanel-usuarios-ini.php

    mv -f /usr/share/gnupanel/estilos/personalizados/gnupanel.com.ar /usr/share/gnupanel/estilos/personalizados/${DOMINIO_PRINCIPAL}


    SUDOKU=`cat /etc/sudoers | grep habilita-dir. | wc -l`
    if [ ${SUDOKU} -ge 2 ]
    then
    NADA=NADA
    else
    cat ${SKEL}/etc/sudo/sudoers >> /etc/sudoers
    fi

    ./permisos_gnupanel_update ${SKEL}

    /etc/init.d/sudo restart
    /etc/init.d/gnupanel-transf restart
    
    }

#########################################################################################################
APT=/usr/bin/apt-get
PROGRAMAS=./listado.apt
CAT=/bin/cat
GREP=/bin/grep
SKEL=skel
CP=/bin/cp
CUSUARIO=/bin/chown
CMODO=/bin/chmod
TIEMPO=`date +%s`

#. configuracion.txt

DIR_GNUPANEL=/usr/share/gnupanel

DIR_BASE=/var/www/sitios/

DIRECTORIO_BACKUP_TEMP=/var/www/gnupanel-backups

USUARIO_ADMIN=admin

IDIOMA_ADMIN=es

DOMINIO_PRINCIPAL=`cat /etc/postfix/main.cf | grep myhostname | mawk -F"=" '{print $2}' | mawk -F" " '{print $1}'`

#########################################################################################################

instala_dependencias

update_gnupanel

#########################################################################################################








