#!/bin/bash

function permisos_directorio
    {
    directorio=$1
    usuario=$2
    grupo=$3
    p_archivo=$4
    p_directorio=$5
    chown -R ${usuario} ${directorio}
    chgrp -R ${grupo} ${directorio}
    chmod ${p_directorio} ${directorio}
    cd ${directorio}
    find . -type d -exec chmod $p_directorio {} \;
    find . -type f -exec chmod $p_archivo {} \;
    }

function permisos_archivo
    {
    archivo=$1
    usuario=$2
    grupo=$3
    p_archivo=$4
    chown ${usuario} ${archivo}
    chgrp ${grupo} ${archivo}
    chmod ${p_archivo} ${archivo}
    }

#########################################################################################################

DIRECTORIO_RAIZ=$1
DIRECTORIO_DESTINO=$2
APLICACION=$3

CONTROL=`/usr/local/gnupanel/bin/habilita-dir.pl ${DIRECTORIO_RAIZ} ${DIRECTORIO_DESTINO} 1`

if [ ${CONTROL} -eq 1 ]
then

permisos_directorio ${DIRECTORIO_RAIZ} ftpuser ftpgroup 0640 0750


case ${APLICACION} in

    joomla )
	chmod 0770 ${DIRECTORIO_DESTINO}administrator/backups
	chmod 0770 ${DIRECTORIO_DESTINO}administrator/components
	chmod 0770 ${DIRECTORIO_DESTINO}administrator/modules
	chmod 0770 ${DIRECTORIO_DESTINO}administrator/templates
	chmod 0770 ${DIRECTORIO_DESTINO}cache
	chmod 0770 ${DIRECTORIO_DESTINO}components
	chmod 0770 ${DIRECTORIO_DESTINO}images
	chmod 0770 ${DIRECTORIO_DESTINO}images/banners
	chmod 0770 ${DIRECTORIO_DESTINO}images/stories
	chmod 0770 ${DIRECTORIO_DESTINO}language
	chmod 0770 ${DIRECTORIO_DESTINO}mambots
	chmod 0770 ${DIRECTORIO_DESTINO}mambots/content
	chmod 0770 ${DIRECTORIO_DESTINO}mambots/editors
	chmod 0770 ${DIRECTORIO_DESTINO}mambots/editors-xtd
	chmod 0770 ${DIRECTORIO_DESTINO}mambots/search
	chmod 0770 ${DIRECTORIO_DESTINO}mambots/system
	chmod 0770 ${DIRECTORIO_DESTINO}media
	chmod 0770 ${DIRECTORIO_DESTINO}modules
	chmod 0770 ${DIRECTORIO_DESTINO}templates
	chmod 0660 ${DIRECTORIO_DESTINO}configuration.php
    ;;

    phpbb )
	chmod 0770 ${DIRECTORIO_DESTINO}images/avatars
    ;;

    backup )
	chown ftpuser:ftpgroup -R ${DIRECTORIO_DESTINO}
	chmod 0640 ${DIRECTORIO_DESTINO}*
	chmod 0750 ${DIRECTORIO_DESTINO}
    ;;

esac

fi

exit

#########################################################################################################







