#!/usr/bin/perl

#############################################################################################################
#
#GNUPanel es un programa para el control de hospedaje WEB 
#Copyright (C) 2006  Ricardo Marcelo Alvarez rmalvarezkai@gmail.com
#
#------------------------------------------------------------------------------------------------------------
#
#Este archivo es parte de GNUPanel.
#
#	GNUPanel es Software Libre; Usted puede redistribuirlo y/o modificarlo
#	bajo los trminos de la GNU Licencia Pblica General (GPL) tal y como ha sido
#	pblicada por la Free Software Foundation; o bien la versin 2 de la Licencia,
#	o (a su opcin) cualquier versin posterior.
#
#	GNUPanel se distribuye con la esperanza de que sea til, pero SIN NINGUNA
#	GARANTA; tampoco las implcitas garantas de MERCANTILIDAD o ADECUACIN A UN
#	PROPSITO PARTICULAR. Consulte la GNU General Public License (GPL) para ms
#	detalles.
#
#	Usted debe recibir una copia de la GNU General Public License (GPL)
#	junto con GNUPanel; si no, escriba a la Free Software Foundation Inc.
#	51 Franklin Street, 5 Piso, Boston, MA 02110-1301, USA.
#
#------------------------------------------------------------------------------------------------------------
#
#This file is part of GNUPanel.
#
#	GNUPanel is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	GNUPanel is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with GNUPanel; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
#------------------------------------------------------------------------------------------------------------
#
#############################################################################################################

use Pg;

sub trim 
{
my($string)=@_;
for ($string)
    {
    s/^\s+//;
    s/\s+$//;
    }
return $string;
}

sub calcula_deudas_reseller
{
    my $conexion = $_[0];
    my $logueo = $_[1];

    my @fila_0;
    open(MENSDIR,">> $logueo");
    my $result_0 = NULL;
    my $deuda = 0;
    my $sql_0 = "SELECT id_reseller,id_plan,vigencia_plan FROM gnupanel_reseller_plan WHERE substring(trim(both ' ' from age(vencimiento_plan,now())) from 1 for 1) = '-' ";
    my $control = 0;
    $result_0 = $conexion->exec($sql_0);
    if($result_0->resultStatus == PGRES_TUPLES_OK)
    {
    while(@fila_0 = $result_0->fetchrow)
	{
	my $id_reseller = $fila_0[0];
	my $id_plan = $fila_0[1];
	my $vigencia = $fila_0[2];
	my $credito = 0;
	my $sql_1 = "SELECT precio FROM gnupanel_reseller_planes WHERE id_plan = $id_plan ";
	$result_1 = $conexion->exec($sql_1);
	$control = 0;
	$deuda = 0;
	
	if(PGRES_TUPLES_OK == $result_1->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    
	    
	my @fila_1;
	if(@fila_1 = $result_1->fetchrow)
	    {
	    $deuda = $deuda + $fila_1[0];
	    }

	$sql_1 = "SELECT dias_de_gracia FROM gnupanel_admin_sets WHERE id_admin = (SELECT cliente_de FROM gnupanel_reseller WHERE id_reseller = $id_reseller) ";
	$result_1 = $conexion->exec($sql_1);
	$control = 0;

	if(PGRES_TUPLES_OK == $result_1->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    

	if(@fila_1 = $result_1->fetchrow)
	    {
	    $dias_de_gracia = $fila_1[0];
	    }

	$sql_2 = "SELECT credito FROM gnupanel_divisas_reseller WHERE id_reseller = $id_reseller ";
	$result_2 = $conexion->exec($sql_2);

	if(PGRES_TUPLES_OK == $result_2->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    

	
	if(@fila_2 = $result_2->fetchrow)
	    {
	    $credito = $fila_2[0];
	    }

	my $result_3 = $conexion->exec("BEGIN");
	if(PGRES_COMMAND_OK == $result_3->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    
	

	my $sql_3 = "UPDATE gnupanel_divisas_reseller SET credito = credito - $deuda, vencimiento = now() + interval '$dias_de_gracia days' WHERE id_reseller = $id_reseller ";

	if($credito<0)
	    {
	    $sql_3 = "UPDATE gnupanel_divisas_reseller SET credito = credito - $deuda WHERE id_reseller = $id_reseller ";
	    }
	$result_3 = $conexion->exec($sql_3);

	if(PGRES_COMMAND_OK == $result_3->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    


	$sql_3 = "UPDATE gnupanel_reseller_plan SET vencimiento_plan = vencimiento_plan + interval '$vigencia month' WHERE id_reseller = $id_reseller ";
	$result_3 = $conexion->exec($sql_3);

	if(PGRES_COMMAND_OK == $result_3->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }


	$sql_3 = "UPDATE gnupanel_reseller_estado SET vencimiento_plan = (SELECT vencimiento_plan FROM gnupanel_reseller_plan WHERE id_reseller = $id_reseller ) WHERE id_reseller = $id_reseller ";
	$result_3 = $conexion->exec($sql_3);

	if(PGRES_COMMAND_OK == $result_3->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }

	if($control == 0)
	    {
	    $result_3 = $conexion->exec("END");
	    }
	else
	    {
	    $result_3 = $conexion->exec("ROLLBACK");
	    }
	}

    }
    else
    {
	$mensaje = $conexion->errorMessage;
	print MENSDIR $mensaje;
	print $mensaje;
    }
    close MENSDIR;

}

sub calcula_deudas_extras_reseller
{
    my $conexion = $_[0];
    my $logueo = $_[1];

    my @fila_0;
    open(MENSDIR,">> $logueo");
    my $result_0 = NULL;
    my $deuda = 0;
    my $control = 0;

    my $sql_0 = "SELECT id_reseller,id_extra FROM gnupanel_reseller_extras WHERE substring(trim(both ' ' from age(vencimiento_extra,now())) from 1 for 1) = '-' ";
    $result_0 = $conexion->exec($sql_0);

    if($result_0->resultStatus == PGRES_TUPLES_OK)
    {
    while(@fila_0 = $result_0->fetchrow)
	{
	my $id_reseller = $fila_0[0];
	my $id_extra = $fila_0[1];
	my $sql_1 = "SELECT periodo,precio FROM gnupanel_reseller_precios_extras WHERE id_extra = $id_extra ";
	my $result_1 = $conexion->exec($sql_1);
	my $periodo = 0;
	my @fila_1;

	if(PGRES_TUPLES_OK == $result_1->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }

	if(@fila_1 = $result_1->fetchrow)
	    {
	    $periodo = $fila_1[0];
	    $deuda = $fila_1[1];
	    }

	$sql_1 = "SELECT dias_de_gracia FROM gnupanel_admin_sets WHERE id_admin = (SELECT cliente_de FROM gnupanel_reseller WHERE id_reseller = $id_reseller) ";
	$result_1 = $conexion->exec($sql_1);

	if(PGRES_TUPLES_OK == $result_1->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    

	if(@fila_1 = $result_1->fetchrow)
	    {
	    $dias_de_gracia = $fila_1[0];
	    }

	$sql_1 = "SELECT credito FROM gnupanel_divisas_reseller WHERE id_reseller = $id_reseller ";
	$result_1 = $conexion->exec($sql_1);

	if(PGRES_TUPLES_OK == $result_1->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    
	
	if(@fila_1 = $result_1->fetchrow)
	    {
	    $credito = $fila_1[0];
	    }

	if(@fila_1 = $result_1->fetchrow)
	    {
	    $periodo = $fila_1[0];
	    $deuda = $fila_1[1];
	    }

	$result_1 = $conexion->exec("BEGIN");
	if(PGRES_COMMAND_OK == $result_1->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    

	$sql_1 = "UPDATE gnupanel_divisas_reseller SET credito = credito - $deuda, vencimiento = now() + interval '$dias_de_gracia days' WHERE id_reseller = $id_reseller ";
	if($credito<0)
	    {
	    $sql_1 = "UPDATE gnupanel_divisas_reseller SET credito = credito - $deuda WHERE id_reseller = $id_reseller ";
	    }

	$result_1 = $conexion->exec($sql_1);


	$sql_1 = "UPDATE gnupanel_reseller_extras SET vencimiento_extra = vencimiento_extra + interval '$periodo month' WHERE id_reseller = $id_reseller AND id_extra = $id_extra ";
	$result_1 = $conexion->exec($sql_1);

	if(PGRES_COMMAND_OK == $result_1->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }

	if($control == 0)
	    {
	    $result_1 = $conexion->exec("END");
	    }
	else
	    {
	    $result_1 = $conexion->exec("ROLLBACK");
	    }

	}
    }
    else
    {
	$mensaje = $conexion->errorMessage;
	print MENSDIR $mensaje;
	print $mensaje;
    }

    close MENSDIR;
}

#######################################################################################################################
#######################################################################################################################
#######################################################################################################################
#######################################################################################################################

sub calcula_deudas_usuarios
{
    my $conexion = $_[0];
    my $logueo = $_[1];

    my @fila_0;
    open(MENSDIR,">> $logueo");
    my $result_0 = NULL;
    my $deuda = 0;
    my $sql_0 = "SELECT id_usuario,id_plan,vigencia_plan FROM gnupanel_usuario_plan WHERE substring(trim(both ' ' from age(vencimiento_plan,now())) from 1 for 1) = '-' ";
    my $control = 0;
    $result_0 = $conexion->exec($sql_0);
    if($result_0->resultStatus == PGRES_TUPLES_OK)
    {
    while(@fila_0 = $result_0->fetchrow)
	{
	my $id_usuario = $fila_0[0];
	my $id_plan = $fila_0[1];
	my $vigencia = $fila_0[2];
	my $credito = 0;
	my $sql_1 = "SELECT precio FROM gnupanel_usuarios_planes WHERE id_plan = $id_plan ";
	$result_1 = $conexion->exec($sql_1);
	$control = 0;
	$deuda = 0;
	
	if(PGRES_TUPLES_OK == $result_1->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    
	    
	my @fila_1;
	if(@fila_1 = $result_1->fetchrow)
	    {
	    $deuda = $deuda + $fila_1[0];
	    }

	$sql_1 = "SELECT dias_de_gracia FROM gnupanel_reseller_sets WHERE id_reseller = (SELECT cliente_de FROM gnupanel_usuario WHERE id_usuario = $id_usuario) ";
	$result_1 = $conexion->exec($sql_1);
	$control = 0;

	if(PGRES_TUPLES_OK == $result_1->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    

	if(@fila_1 = $result_1->fetchrow)
	    {
	    $dias_de_gracia = $fila_1[0];
	    }

	$sql_2 = "SELECT credito FROM gnupanel_divisas_usuario WHERE id_usuario = $id_usuario ";
	$result_2 = $conexion->exec($sql_2);

	if(PGRES_TUPLES_OK == $result_2->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    

	
	if(@fila_2 = $result_2->fetchrow)
	    {
	    $credito = $fila_2[0];
	    }

	my $result_3 = $conexion->exec("BEGIN");
	if(PGRES_COMMAND_OK == $result_3->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    
	

	my $sql_3 = "UPDATE gnupanel_divisas_usuario SET credito = credito - $deuda, vencimiento = now() + interval '$dias_de_gracia days' WHERE id_usuario = $id_usuario ";

	if($credito<0)
	    {
	    $sql_3 = "UPDATE gnupanel_divisas_usuario SET credito = credito - $deuda WHERE id_usuario = $id_usuario ";
	    }
	$result_3 = $conexion->exec($sql_3);

	if(PGRES_COMMAND_OK == $result_3->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    


	$sql_3 = "UPDATE gnupanel_usuario_plan SET vencimiento_plan = vencimiento_plan + interval '$vigencia month' WHERE id_usuario = $id_usuario ";
	$result_3 = $conexion->exec($sql_3);

	if(PGRES_COMMAND_OK == $result_3->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }


	$sql_3 = "UPDATE gnupanel_usuario_estado SET vencimiento_plan = (SELECT vencimiento_plan FROM gnupanel_usuario_plan WHERE id_usuario = $id_usuario ) WHERE id_usuario = $id_usuario ";
	$result_3 = $conexion->exec($sql_3);

	if(PGRES_COMMAND_OK == $result_3->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }

	if($control == 0)
	    {
	    $result_3 = $conexion->exec("END");
	    }
	else
	    {
	    $result_3 = $conexion->exec("ROLLBACK");
	    }
	}

    }
    else
    {
	$mensaje = $conexion->errorMessage;
	print MENSDIR $mensaje;
	print $mensaje;
    }
    close MENSDIR;

}

sub calcula_deudas_extras_usuario
{
    my $conexion = $_[0];
    my $logueo = $_[1];

    my @fila_0;
    open(MENSDIR,">> $logueo");
    my $result_0 = NULL;
    my $deuda = 0;
    my $control = 0;

    my $sql_0 = "SELECT id_usuario,id_extra FROM gnupanel_usuario_extras WHERE substring(trim(both ' ' from age(vencimiento_extra,now())) from 1 for 1) = '-' ";
    $result_0 = $conexion->exec($sql_0);

    if($result_0->resultStatus == PGRES_TUPLES_OK)
    {
    while(@fila_0 = $result_0->fetchrow)
	{
	my $id_usuario = $fila_0[0];
	my $id_extra = $fila_0[1];
	my $sql_1 = "SELECT periodo,precio FROM gnupanel_usuarios_precios_extras WHERE id_extra = $id_extra ";
	my $result_1 = $conexion->exec($sql_1);
	my $periodo = 0;
	my @fila_1;

	if(PGRES_TUPLES_OK == $result_1->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }

	if(@fila_1 = $result_1->fetchrow)
	    {
	    $periodo = $fila_1[0];
	    $deuda = $fila_1[1];
	    }

	$sql_1 = "SELECT dias_de_gracia FROM gnupanel_reseller_sets WHERE id_reseller = (SELECT cliente_de FROM gnupanel_usuario WHERE id_usuario = $id_usuario) ";
	$result_1 = $conexion->exec($sql_1);

	if(PGRES_TUPLES_OK == $result_1->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    

	if(@fila_1 = $result_1->fetchrow)
	    {
	    $dias_de_gracia = $fila_1[0];
	    }

	$sql_1 = "SELECT credito FROM gnupanel_divisas_usuario WHERE id_usuario = $id_usuario ";
	$result_1 = $conexion->exec($sql_1);

	if(PGRES_TUPLES_OK == $result_1->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    
	
	if(@fila_1 = $result_1->fetchrow)
	    {
	    $credito = $fila_1[0];
	    }

	if(@fila_1 = $result_1->fetchrow)
	    {
	    $periodo = $fila_1[0];
	    $deuda = $fila_1[1];
	    }

	$result_1 = $conexion->exec("BEGIN");
	if(PGRES_COMMAND_OK == $result_1->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }    

	$sql_1 = "UPDATE gnupanel_divisas_usuario SET credito = credito - $deuda, vencimiento = now() + interval '$dias_de_gracia days' WHERE id_usuario = $id_usuario ";
	if($credito<0)
	    {
	    $sql_1 = "UPDATE gnupanel_divisas_usuario SET credito = credito - $deuda WHERE id_usuario = $id_usuario ";
	    }

	$result_1 = $conexion->exec($sql_1);

	$sql_1 = "UPDATE gnupanel_usuario_extras SET vencimiento_extra = vencimiento_extra + interval '$periodo month' WHERE id_usuario = $id_usuario AND id_extra = $id_extra ";
	$result_1 = $conexion->exec($sql_1);

	if(PGRES_COMMAND_OK == $result_1->resultStatus)
	    {
	    }
	else
	    {
	    $control = $control + 1;
	    }

	if($control == 0)
	    {
	    $result_1 = $conexion->exec("END");
	    }
	else
	    {
	    $result_1 = $conexion->exec("ROLLBACK");
	    }

	}
    }
    else
    {
	$mensaje = $conexion->errorMessage;
	print MENSDIR $mensaje;
	print $mensaje;
    }

    close MENSDIR;
}

#######################################################################################################################
## Put ourselves in background if not in debug mode. 
require "/etc/gnupanel/gnupanel.conf.pl";

$nombre = $0;
$nombre = substr($nombre,rindex($nombre,"/")+1,length($nombre)-1);

$logueo = "/var/log/".$nombre.".log";
$conexion = NULL;
$reloaded = 0;

#open(STDERR, ">> $logueo");

#Inicio del programa
#open(STDOUT, ">> $logueo");

$conexion = NULL;
$conexion = Pg::connectdb("dbname=$database host=localhost user=$userdb password=$pasaportedb");
	    
$estado = $conexion->status;

if($estado==PGRES_CONNECTION_OK)
    {
    calcula_deudas_reseller($conexion,$logueo);
    calcula_deudas_extras_reseller($conexion,$logueo);
    calcula_deudas_usuarios($conexion,$logueo);
    calcula_deudas_extras_usuario($conexion,$logueo);
    }
else
    {
    $mensaje = $conexion->errorMessage;
    open(MENSAGES,">> $logueo");
    print MENSAGES $mensaje;
    close MENSAGES;
    $conexion->reset;
    }

#fin del programa
	
    
##$end = 0;

###############################################################################################################################################################





    

