#!/usr/bin/perl

#############################################################################################################
#
#GNUPanel es un programa para el control de hospedaje WEB 
#Copyright (C) 2006  Ricardo Marcelo Alvarez rmalvarezkai@gmail.com
#
#------------------------------------------------------------------------------------------------------------
#
#Este archivo es parte de GNUPanel.
#
#	GNUPanel es Software Libre; Usted puede redistribuirlo y/o modificarlo
#	bajo los trminos de la GNU Licencia Pblica General (GPL) tal y como ha sido
#	pblicada por la Free Software Foundation; o bien la versin 2 de la Licencia,
#	o (a su opcin) cualquier versin posterior.
#
#	GNUPanel se distribuye con la esperanza de que sea til, pero SIN NINGUNA
#	GARANTA; tampoco las implcitas garantas de MERCANTILIDAD o ADECUACIN A UN
#	PROPSITO PARTICULAR. Consulte la GNU General Public License (GPL) para ms
#	detalles.
#
#	Usted debe recibir una copia de la GNU General Public License (GPL)
#	junto con GNUPanel; si no, escriba a la Free Software Foundation Inc.
#	51 Franklin Street, 5 Piso, Boston, MA 02110-1301, USA.
#
#------------------------------------------------------------------------------------------------------------
#
#This file is part of GNUPanel.
#
#	GNUPanel is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	GNUPanel is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with GNUPanel; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
#------------------------------------------------------------------------------------------------------------
#
#############################################################################################################

use Pg;

sub trim 
{
my($string)=@_;
for ($string)
    {
    s/^\s+//;
    s/\s+$//;
    }
return $string;
}

sub crea_directorio
    {
    my $directorio_in = $_[0];
    my $comando = "/bin/mkdir -p -m 0750 ";
    my $comandar = "";
    my $directorio = $directorio_in;
    my $directorio_raiz_sitios_in = trim($directorio_raiz_sitios);
    my $caracter = chop($directorio_raiz_sitios_in);
    if(!($caracter eq "/"))
	{
	$directorio_raiz_sitios_in = $directorio_raiz_sitios_in.$caracter;
	}
    
    $directorio =~ s/$directorio_raiz_sitios_in//;
    @data = split("/",$directorio);

    my $raiz = $directorio_raiz_sitios_in;
    chomp($raiz);
    foreach $partes(@data)
	{
	if(length($partes)>0)
	    {
	    $raiz = $raiz."/".$partes;
	    $comandar = $comando.$raiz;
	    if (!(-e $raiz))
		{
    		my $comandar = $comando.$raiz;
		system($comandar);
		chown(scalar(getpwnam($usuario_dir_apache)),scalar(getgrnam($grupo_dir_apache)),$raiz);
		}    
	    }
	}

    $comando = "/bin/mkdir -p -m 0550 ";

    $dir_agreg = pone_barra($directorio_in)."gnupanel";
    $comandar = $comando.$dir_agreg;
    system($comandar);

    $dir_agreg = pone_barra($directorio_in)."gnupanel/awstats";
    $comandar = $comando.$dir_agreg;
    system($comandar);
    
    $dir_agreg = pone_barra($directorio_in)."gnupanel/webalizer";
    $comandar = $comando.$dir_agreg;
    system($comandar);
    }

sub pone_barra
    {
    my $directorio_in = $_[0];
    my $directorio = trim($directorio_in);
    my $caracter = chop($directorio);
    if($caracter eq "/")
	{
	$directorio = $directorio.$caracter;
	}
    else
	{
	$directorio = $directorio.$caracter."/";
	}	
    $directorio = $directorio;    
    }

sub genera_estadisticas
{
    my $conexion = $_[0];
    my $logueo = $_[1];
    my @fila;
    my @fila_0;
    open(MENSDIR,">> $logueo");
    my $result = NULL;
    my $result_0 = NULL;
    
    my $sql = "SELECT * FROM gnupanel_apacheconf WHERE estado = 9";
    $result = $conexion->exec($sql);
    if($result->resultStatus == PGRES_TUPLES_OK)
    {
    while(@fila = $result->fetchrow)
	{
	my $directorio = $fila[6];
	my $server_admin = $fila[7];
	my $ip = $fila[4];
	my $subdominio = $fila[3];
	my $id_subdominio = $fila[1];
	my $id_dominio = $fila[2];
	my $tiene_ssl = $fila[10];
	my $estado = $fila[14];
	my $redirigir = $fila[8];
	my $dominio_destino = $fila[9];
	my $id_apache = $fila[0];
	my $php_register_globals = $fila[11];
	my $php_safe_mode = $fila[12];
	my $indexar = $fila[13];
	my $activo = $fila[15];
	
	my $sql_sub_0 = "(SELECT id_servidor FROM gnupanel_servidores WHERE servidor = '$nombre_servidor')";
	my $sql_sub_1 = "(SELECT ip_publica FROM gnupanel_ips_servidor WHERE CASE WHEN id_servidor = $sql_sub_0 THEN ip_publica = '$ip' OR ip_privada = '$ip' ELSE false END)";
	$sql = "SELECT dominio FROM gnupanel_usuario WHERE id_usuario = $id_dominio AND EXISTS $sql_sub_1 ";

	$result_0 = $conexion->exec($sql);
	if($result_0->resultStatus == PGRES_TUPLES_OK)
	    {
	    @fila_0 = $result_0->fetchrow;
	    my $dominio = $fila_0[0];
	    if($estado == 9)
		{

	        my $dir_admin = "/usr/share/gnupanel/admin/";
		my $dir_reseller = "/usr/share/gnupanel/reseller/";
		my $dir_usuarios = "/usr/share/gnupanel/usuarios/";
		my $dir_add_ons = "/usr/share/gnupanel/add-ons/";
    		my $dir_mail = "/usr/share/gnupanel/mail/";
    		my $dir_gnupanel = "/usr/share/gnupanel/gnupanel/";
    		my $dir_default = "/usr/share/gnupanel/gnupanel/";

		if(($dir_admin eq pone_barra($directorio)) || ($dir_reseller eq pone_barra($directorio)) || ($dir_usuarios eq pone_barra($directorio)) || ($dir_add_ons eq pone_barra($directorio)) || ($dir_mail eq pone_barra($directorio)) || ($dir_gnupanel eq pone_barra($directorio)) || ($dir_default eq pone_barra($directorio)))
		    {
		    }
		else
		    {
		    if(!($subdominio eq "gnupanel"))
			{
			genera_webalizer($subdominio,$dominio,$directorio,$tiene_ssl);
			genera_awstats($subdominio,$dominio,$directorio,$tiene_ssl);
			genera_index($subdominio,$dominio,$directorio,$tiene_ssl);
			}
		    }
		}
	    }
	}
    }
    else
    {
	$mensaje = $conexion->errorMessage;
	print MENSDIR $mensaje;
	print $mensaje;
    }
    close MENSDIR;
}

sub dame_archivo_log
{
    my $subdominio = $_[0];
    my $dominio = $_[1];
    my $tiene_ssl = $_[2];

    my $archivo_log = $dominio;
    if(length($subdominio)>0)
	{
	$archivo_log = $subdominio.".".$archivo_log;	
	}

    if($tiene_ssl == 1)
	{
	$archivo_log = "ssl.".$subdominio.".".$archivo_log;	
	}

    $archivo_log = "/var/log/apache2/".$archivo_log.".log";
    $archivo_log = $archivo_log;
}

sub genera_awstats
{
    my $subdominio = $_[0];
    my $dominio = $_[1];
    my $directorio = $_[2];
    my $tiene_ssl = $_[3];
    my $archivo_log = dame_archivo_log($subdominio,$dominio,$tiene_ssl);
    $directorio = pone_barra($directorio)."gnupanel/awstats/";
    
    my $archivo_awstats = "/etc/awstats/awstats.".$dominio.".conf";
    my $dominio_aw = $dominio;

    if(length($subdominio)>0)
	{
	$archivo_awstats = "/etc/awstats/awstats.".$subdominio.".".$dominio.".conf";
	$dominio_aw = $subdominio.".".$dominio;
	}

    my $borrar = "rm -f ".$archivo_awstats;
    my $comando = "/usr/local/gnupanel/genera_awstats $dominio_aw $directorio";
    
    open(AWSTAT,"> $archivo_awstats");
    print AWSTAT "LogType=W \n";
    print AWSTAT "LogFile=\"$archivo_log\" \n";
    print AWSTAT "LogFormat=1 \n";
    print AWSTAT "SiteDomain=\"$dominio_aw\" \n";
    close AWSTAT;
    system($comando);
    $comando = "/bin/chown -R ftpuser:ftpgroup ".$directorio;
    system($comando);
    $comando = "/bin/chmod 440 ".$directorio."*";
    system($comando);
    system($borrar);
}

sub genera_webalizer
{
    my $subdominio = $_[0];
    my $dominio = $_[1];
    my $directorio = $_[2];
    my $tiene_ssl = $_[3];
    my $archivo_log = dame_archivo_log($subdominio,$dominio,$tiene_ssl);
    $directorio = pone_barra($directorio)."gnupanel/webalizer/";
    
    my $dominio_web = $dominio;

    if(length($subdominio)>0)
	{
	$dominio_web = $subdominio.".".$dominio;
	}

    my $comando = "/usr/bin/zmergelog ".$archivo_log."* | /usr/bin/env LANG=en_US LC_ALL=en_US LC_CTYPE=en_US.ISO8859-1 LC_MESSAGES=en_US /usr/bin/webalizer -x php -n ".$dominio_web." -o ".$directorio." - " ;
    system($comando);
    $comando = "/bin/chown -R ftpuser:ftpgroup ".$directorio;
    system($comando);
    $comando = "/bin/chmod 440 ".$directorio."*";
    system($comando);
}

sub genera_index
{
    my $subdominio = $_[0];
    my $dominio = $_[1];
    my $directorio = $_[2];
    my $tiene_ssl = $_[3];
    my $archivo_log = dame_archivo_log($subdominio,$dominio,$tiene_ssl);
    $archivo_index = pone_barra($directorio)."gnupanel/index.php";
    $archivo_estilo = "/usr/local/gnupanel/estilo-stats.css";    
    my $link_aw = "awstats/awstats.".$dominio.".html";
    my $link_web = "webalizer/index.php";
    my $renglon;
    
    if(length($subdominio)>0)
	{
	$link_aw = "awstats/awstats.".$subdominio.".".$dominio.".html";
	}

    open(INDICE,"> $archivo_index");
    print INDICE "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\"> \n";
    
    print INDICE "<html> \n";
    print INDICE "<head> \n";
    print INDICE "<title>Stats </title> \n";


    print INDICE "<STYLE type=\"text/css\" > \n";

    open(ESTILOS,$archivo_estilo);

    while(eof(ESTILOS)==0)
	{
	$renglon = <ESTILOS>;
	print INDICE $renglon;
	}

    close ESTILOS;
    
    print INDICE "</STYLE> \n";

    print INDICE "</head> \n";
    print INDICE "<body> \n";

    print INDICE "<div class=\"cabecera\" > \n";
    print INDICE "</div> \n";
    

    print INDICE "<div class=\"contenedor\" > \n";

    print INDICE "<div class=\"botonera\" > \n";
    print INDICE "</div> \n";

    print INDICE "<div class=\"cuerpo\" > \n";

    print INDICE "<br> \n";

    print INDICE "<table> \n";

    print INDICE "<tr> \n";
    print INDICE "<td> \n";
    print INDICE "<a href=\"$link_web\" >\n";
    print INDICE "Webalizer \n";
    print INDICE "</a> \n";
    print INDICE "</td> \n";
    print INDICE "</tr> \n";

    print INDICE "<tr> \n";
    print INDICE "<td> \n";
    print INDICE "<br> \n";
    print INDICE "</td> \n";
    print INDICE "</tr> \n";

    print INDICE "<tr> \n";
    print INDICE "<td> \n";
    print INDICE "<a href=\"$link_aw\" >\n";
    print INDICE "AwStats \n";
    print INDICE "</a> \n";
    print INDICE "</td> \n";
    print INDICE "</tr> \n";

    print INDICE "</table> \n";

    print INDICE "</div> \n";
    print INDICE "</div> \n";
    
    print INDICE "</body> \n";
    print INDICE "</html> \n";
    
    close INDICE;

    $comando = "/bin/chown ftpuser:ftpgroup ".$archivo_index;
    system($comando);
    $comando = "/bin/chmod 440 ".$archivo_index;
    system($comando);


}

#######################################################################################################################
## Put ourselves in background if not in debug mode. 
require "/etc/gnupanel/gnupanel.conf.pl";

$nombre = $0;
$nombre = substr($nombre,rindex($nombre,"/")+1,length($nombre)-1);

$logueo = "/var/log/".$nombre.".log";
$conexion = NULL;
$reloaded = 0;

open(STDERR, ">> $logueo");

#Inicio del programa
open(STDOUT, ">> $logueo");

$conexion = NULL;
$conexion = Pg::connectdb("dbname=$database host=localhost user=$userdb password=$pasaportedb");
	    
$estado = $conexion->status;

if($estado==PGRES_CONNECTION_OK)
    {
    genera_estadisticas($conexion,$logueo);
    }
else
    {
    $mensaje = $conexion->errorMessage;
    open(MENSAGES,">> $logueo");
    print MENSAGES $mensaje;
    close MENSAGES;
    $conexion->reset;
    }

#fin del programa
	
    
##$end = 0;

###############################################################################################################################################################





    

